#
# 23.08.1999    nixwis  one-Bug - naja von Assembler hab ich
#                       halt keine grosse Ahnung
#
# 22.08.1999    nixwis  Auf 8 Y-Bytes umgestellt. Es werden nur noch
#                       YTmpLines erwartet. Muss noch optimiert werden
# 


.text

.global XlinediffASM # unsigned int XlinediffASM (unsigned char *tmpbaseline, unsigned char *tmpline,
                     #                            int skip, int xWidth, int shift, int step)

## tmpbaseline  8(%ebp)
## tmpline     12(%ebp)
## skip        16(%ebp)
## xWidth      20(%ebp)
## shift       24(%ebp)
## step        28(%ebp)


XlinediffASM: 
        pushl   %ebp
        movl    %esp,%ebp
        pushl   %ebx
        pushl   %ecx
        pushl   %edx
        pushl   %esi
        pushl   %edi

        movl    28(%ebp), %eax          # Step -> eax
        shll    $3,%eax                 # 8 Ys pro MMX Befehl

        movl    8(%ebp), %esi           # TmpBaseline -> esi
        movl    12(%ebp), %edi          # Tmpline -> edi
        addl    24(%ebp), %edi          # edi + shift -> edi

        movl    20(%ebp), %ebx          # xWidth -> ebx
        subl    16(%ebp), %ebx          # ebx - skip -> ebx

        xorl    %ecx,%ecx               # ecx = 0

        psllq   $64,%mm6                # mm6 = 0
        psllq   $64,%mm7                # mm7 = 0

n4:     movq    (%esi,%ecx),%mm0        # TmpBaseline -> mm0
        movq    (%edi,%ecx),%mm1        # TmpLine (inkl. shift) -> mm1

        movq    %mm0,%mm2               # mm0 sichern
        psubusb %mm1,%mm0               # mm0 = mm0 - mm1 (saturated)
        psubusb %mm2,%mm1               # mm1 = mm1 - mm2 (saturated)
        por     %mm1,%mm0               # mm0 = mm0 | mm1

        movq    %mm0,%mm1               # Auspacken in Woerter
        punpcklbw %mm6,%mm0
        psrlq   $32,%mm1
        punpcklbw %mm6,%mm1
        paddw   %mm0,%mm7               # Summieren (reicht fuer max 4*256 Y-Werte)
        paddw   %mm1,%mm7

        addl    %eax,%ecx               # Naechster Block
        cmpl    %ebx,%ecx
        jl      n4

        movq    XlinediffASM.one,%mm6   # Jeweils 2 Woerter addieren
        pmaddwd %mm6,%mm7

        movq    %mm7,%mm6               # Ergebnis summieren
        psrlq   $32,%mm6
        paddd   %mm7,%mm6
        movd    %mm6,%eax

        emms
        popl    %edi
        popl    %esi
        popl    %edx
        popl    %ecx
        popl    %ebx
        leave
        ret

XlinediffASM.one: .long 0x00010001,0x00010001
