%define         ver     1.4.3
%define		prefix	/usr

# workaround a bug in rpm 3.0.4:
#   by default it modifies the files installed by my %install
#   scriptlet (compresses the man-pages), but failes to update
#   the %files section too.
%define __os_install_post       true

Summary: Video4Linux Stream Capture Viewer and Descrambler
Name: xawdecode-plugin
Version: %{ver}
Release: 1
Source0: xawdecode-plugin-%{version}.tar.gz
Group: X11/Applications
Requires: xawdecode >= 1.6.0-0
BuildPreReq: xawdecode >= 1.6.4-0
Copyright: GNU GENERAL PUBLIC LICENSE
BuildRoot: /var/tmp/xawdecode-plugin-%{version}.root

%description
Descrambler plugin for Xawdecode

%prep
%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} --with-xawdecode-prefix=%{prefix}
make

%install
rm -rf $RPM_BUILD_ROOT  /tmp/files.lst
make ROOT="$RPM_BUILD_ROOT" prefix="$RPM_BUILD_ROOT"%{prefix} install

%files
%{prefix}/lib/libxawdecode.a
%{prefix}/lib/libxawdecode.so
%{prefix}/lib/libxawdecode-%{version}.so
%{prefix}/lib/libxawdecode.la
%{prefix}/man/man1/xawdecode-plugin.1
%doc AUTHORS COPYING INSTALL NEWS README ChangeLog Readme.txt lisez-moi lisez-moi.txt
%doc old/* FAQfr-xawdecode-plugin FAQfr-xawdecode-plugin.txt
%doc lircrc.miro.sample lircrc.hauppauge.sample xawdecoderc.sample xawdecode-plugin.spec

%clean
rm -rf $RPM_BUILD_ROOT /tmp/files.lst

%post
PATH="$PATH:/sbin" ldconfig -n %{prefix}/lib

